package tf.bug.loaf

import eu.timepit.refined.api.Refined
import eu.timepit.refined.numeric.Interval
import singleton.ops._

case class Matrix[M <: Int : ValueOf, N <: Int : ValueOf](columsOfVectors: SList[SList[Double, M], N])(implicit bound1: Require[M > 0], bound2: Require[N > 0]) {

  val rows: Int = valueOf[M]
  val cols: Int = valueOf[N]

  def apply(i: Int Refined Interval.ClosedOpen[0, M], j: Int Refined Interval.ClosedOpen[0, N]): Double = columsOfVectors.value(j.value).value(i.value)

}
